# $Id: Widget.py,v 1.5 2005/04/02 17:58:58 asc Exp $

__author__     = "Aaron Straup Cope"
__url__        = "http://www.aaronland.info/python/MirrorProjectWidget/"
__version__    = "1.0"
__cvsversion__ = "$Revision: 1.5 $"
__date__       = "$Date: 2005/04/02 17:58:58 $"
__copyright__  = "Copyright (c) 2005 Aaron Straup Cope."
__license__    = "GNU GPL 2"

import wx

from MirrorProjectWidget.Constants import *

from ImageWidget.Constants import IMAGEWIDGET_ID_ABOUT,IMAGEWIDGET_ERR_POLLING,IMAGEWIDGET_ERR_STREAMIFY

from ImageWidget.Widget    import ImageWidget
from ImageWidget.Error     import ImageWidgetError

from ImageWidgetDeliciousTool.Tool import DeliciousTool
import cStringIO;

from urllib import unquote_plus;
import xmlrpclib

class MirrorProjectWidget (ImageWidget,DeliciousTool) : 

    def __init__(self) :
	self.list = [];
	self.cc   = {};

        self.api = xmlrpclib.Server(MIRRORPROJECT_URL)

	ImageWidget.__init__(self);

    #

    def Setup (self,name,uri) :

	frame = ImageWidget.Setup(self,
				  MIRRORPROJECT_TITLE,
				  MIRRORPROJECT_NAMESPACE)
	
	wx.EVT_MENU(frame,
		    IMAGEWIDGET_ID_ABOUT,
		    self.About)

	wx.EVT_KEY_DOWN(frame.Panel,
			self.KeyDown)

	# del.icio.us

	DeliciousTool.Setup(self,frame)

	return frame;

    #

    def About (self,event) :

	ImageWidget.About(self,
			  event,
			  MIRRORPROJECT_TITLE,
			  MIRRORPROJECT_ABOUT)

    #

    def DeliciousTags (self) :
	return MIRRORPROJECT_DELICIOUS_TAGS

    #

    def KeyDown (self,event) :

	keyname = self.GetKeyDown(event)

	if keyname == "" :
	    event.Skip()
	    return True
        
	#

	if keyname == "A":
            self.About(event)	    
	elif self.DeliciousKeyDown(keyname) :
	    return self.DeliciousKeyDown(keyname,event)
	else :
	    return self.GetTopWindow().KeyDown(event)

    #

    def GetImage (self) :

        try:
            resp = self.api.mirror.RandomImage()
        except Exception, e:
            raise ImageWidgetError(IMAGEWIDGET_ERR_POLLING,e);

        try:
            stream = cStringIO.StringIO(resp["image"].data)         
        except Exception, e:
	    raise ImageWidgetError(IMAGEWIDGET_ERR_STREAMIFY,e);

	# please, there's nothing you could say
	# that I haven't already said myself - it
	# will all be fixed, you know, sometime...

	self.Log("info","got mirror ID %s" % resp['uid'])

	creator = unicode(unquote_plus(resp["who"]),MIRRORPROJECT_ENCODING);
	title   = unicode(unquote_plus(resp["what"]),MIRRORPROJECT_ENCODING);
	where   = unicode(unquote_plus(resp["where"]),MIRRORPROJECT_ENCODING);
	date    = unicode(unquote_plus(resp["when"]),MIRRORPROJECT_ENCODING);
	url     = unicode(resp["url"],MIRRORPROJECT_ENCODING);
	uid     = unicode(resp["uid"],MIRRORPROJECT_ENCODING);

	return {'image':stream,
		'title':title,
		'description':u'',
		'location':where,
		'date':date,
		'url':url,
		'uid':uid,
		'license':MIRRORPROJECT_IMAGE_LICENSE,
		'creator':creator};


    #

    def PostToDelicious (self,event) :
	fmt = u"The Mirror Project - %s, %s"
	DeliciousTool.PostToDelicious(self,event,fmt)

if __name__ == "__main__" :
    widgt = MirrorProjectWidget();
    widgt.MainLoop();

